#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include "resource.h"

HINSTANCE hIns;
HBITMAP hSkin;
RECT rcClient, rcText;
int nLines  = 0;
int TextLen = 0;
LOGFONT	lf;
HFONT hFont;
int ScrollConst =1;
COLORREF CLR;
LONG cx,cy;
HDC hdcBackground;
int ndcBackground;
char Text[] = "Simple flicker free text scrolling\nCoded by Tejashwi Kalp Taru\n\nEnjoy the double buffer\n\nThanks to codeproject.com for a nice place\nfor developer to developer";

BOOL CALLBACK DlgProc(HWND hWnd,UINT message,WPARAM wParam,LPARAM lParam)
{
	switch(message)
	{
		case WM_INITDIALOG:
			{
				// Loads the bitmap, get its CX,CY and get compatibe device context 
				hSkin   = LoadBitmap(hIns,MAKEINTRESOURCE(IDB_BITMAP1));
				BITMAP bm = {0};
				GetObject( hSkin, sizeof(bm), &bm );
				cx = bm.bmWidth;
				cy = bm.bmHeight;
				HDC hdcScreen = GetDC(hWnd);
				hdcBackground = CreateCompatibleDC(hdcScreen);
				ndcBackground = SaveDC(hdcBackground);
				SelectObject(hdcBackground, hSkin);
				ReleaseDC(hWnd, hdcScreen);
				//------------------------------------------------------------------

				// Counts the number of lines in scroll text
				TextLen = lstrlen(Text);
				for(int i=0;i<TextLen;i++)
				{
					if(Text[i]=='\n')
						nLines++;
				}
				//------------------------------------------

				// Create a font as desired
				ZeroMemory(&lf, sizeof(LOGFONT));
				strcpy(lf.lfFaceName,"Lucida Console");
				lf.lfHeight = 20;
				lf.lfWeight = FW_BOLD;
				lf.lfQuality = ANTIALIASED_QUALITY;
				hFont=CreateFontIndirect(&lf);
				GetClientRect(hWnd, &rcClient);
				//-----------------------------------
				
				// Gets the size of total scroll texts
				SIZE sizeAboutText;
				HDC hDC = GetDC(hWnd);
				HDC hDCMem = CreateCompatibleDC(hDC);
				SelectObject(hDCMem, hFont);
				GetTextExtentPoint32A(hDCMem, Text, TextLen, &sizeAboutText);
				ReleaseDC(hWnd,hDC);
				DeleteDC(hDCMem);
				//-----------------------------------------------------------

				// Calculates the needed size for given scroller text
				rcText.bottom += (sizeAboutText.cy * (nLines+3))+rcClient.bottom;
				rcText.top = rcClient.bottom;
				rcText.right = rcClient.right;
				rcText.left = rcClient.left;
				//----------------------------------------------------------------

				SetTimer(hWnd, 1, 20, NULL); // Starts timer of duration of 20MS
			}
			return TRUE;
		case WM_TIMER:
			// Check and set the current range of scroll text and sets color of text accordingly
			rcText.top+=ScrollConst;
			rcText.bottom+=ScrollConst;
			if(rcText.top>=rcClient.bottom+10)
			{
				ScrollConst=-1;
				CLR=RGB(0,0,255);
			}
			if(rcText.bottom<=rcClient.top)
			{
				ScrollConst=1;
				CLR=RGB(255,0,0);
			}
			//-----------------------------------------------------------------------------------
			InvalidateRect(hWnd, NULL, FALSE); // Invalidates the window, WM_PAINT caused !!!
			return TRUE;
		case WM_PAINT:
			{
				PAINTSTRUCT ps;
				if(BeginPaint(hWnd,&ps))
				{
					//Creating double buffer
					HDC hdcMem = CreateCompatibleDC(ps.hdc);
					int ndcmem = SaveDC(hdcMem);
					HBITMAP hbmMem = CreateCompatibleBitmap(ps.hdc, cx, cy);
					SelectObject(hdcMem, hbmMem);
					//-------------------------------------------------------

					// Copy background bitmap into double buffer
					BitBlt(hdcMem, 0, 0, cx, cy, hdcBackground, 0, 0, SRCCOPY);
					//---------------------------------------------------------

					// Draw the text
					SelectObject(hdcMem, hFont);
					SetTextColor(hdcMem, CLR);
					SetBkMode(hdcMem, TRANSPARENT);
					DrawText(hdcMem,Text,-1,&rcText,DT_CENTER | DT_TOP | DT_NOPREFIX | DT_NOCLIP);
					//-----------------------------------------------------------------------------

					// Copy double buffer to screen
					BitBlt(ps.hdc, 0, 0, cx, cy, hdcMem, 0, 0, SRCCOPY);
					//--------------------------------------------------

					// Clean up
					RestoreDC(hdcMem, ndcmem);
					DeleteObject(hbmMem);
					DeleteDC(hdcMem);
					EndPaint(hWnd, &ps);
					//--------------------
				}
				else
				{
					KillTimer(hWnd,1);
					MessageBox(hWnd,"Unable to render graphics\nError : Can not start painting!","Error",MB_ICONERROR);
				}
			}
			return TRUE;
		case WM_CLOSE:
			KillTimer(hWnd,1);
			RestoreDC(hdcBackground, ndcBackground);
			DeleteDC(hdcBackground);
			DeleteObject(hSkin);
			DeleteObject(hFont);
			EndDialog(hWnd,0);
			return TRUE;
	}
	return FALSE;
}

int WINAPI WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,int nShowCmd)
{
	hIns = hInstance;
	DialogBoxParam(hInstance,MAKEINTRESOURCE(IDD_DIALOG1),NULL,DLGPROC(DlgProc),0);
}